// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: database.proto

#include "database.pb.h"

#include <algorithm>

#include <google/protobuf/stubs/common.h>
#include <google/protobuf/stubs/port.h>
#include <google/protobuf/stubs/once.h>
#include <google/protobuf/io/coded_stream.h>
#include <google/protobuf/wire_format_lite_inl.h>
#include <google/protobuf/descriptor.h>
#include <google/protobuf/generated_message_reflection.h>
#include <google/protobuf/reflection_ops.h>
#include <google/protobuf/wire_format.h>
// This is a temporary google only hack
#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
#include "third_party/protobuf/version.h"
#endif
// @@protoc_insertion_point(includes)
namespace mascot {
class DirectoryReplyDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<DirectoryReply>
      _instance;
} _DirectoryReply_default_instance_;
class DbDevExportInfoDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<DbDevExportInfo>
      _instance;
} _DbDevExportInfo_default_instance_;
class DbDevImportInfoDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<DbDevImportInfo>
      _instance;
} _DbDevImportInfo_default_instance_;
class DbDevExportInfosDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<DbDevExportInfos>
      _instance;
} _DbDevExportInfos_default_instance_;
class DeviceNameDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<DeviceName>
      _instance;
} _DeviceName_default_instance_;
class DirectoryImportReplyDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<DirectoryImportReply>
      _instance;
} _DirectoryImportReply_default_instance_;
}  // namespace mascot
namespace protobuf_database_2eproto {
void InitDefaultsDirectoryReplyImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  protobuf_error_2eproto::InitDefaultsError();
  {
    void* ptr = &::mascot::_DirectoryReply_default_instance_;
    new (ptr) ::mascot::DirectoryReply();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::DirectoryReply::InitAsDefaultInstance();
}

void InitDefaultsDirectoryReply() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsDirectoryReplyImpl);
}

void InitDefaultsDbDevExportInfoImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  {
    void* ptr = &::mascot::_DbDevExportInfo_default_instance_;
    new (ptr) ::mascot::DbDevExportInfo();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::DbDevExportInfo::InitAsDefaultInstance();
}

void InitDefaultsDbDevExportInfo() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsDbDevExportInfoImpl);
}

void InitDefaultsDbDevImportInfoImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  {
    void* ptr = &::mascot::_DbDevImportInfo_default_instance_;
    new (ptr) ::mascot::DbDevImportInfo();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::DbDevImportInfo::InitAsDefaultInstance();
}

void InitDefaultsDbDevImportInfo() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsDbDevImportInfoImpl);
}

void InitDefaultsDbDevExportInfosImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  protobuf_database_2eproto::InitDefaultsDbDevExportInfo();
  {
    void* ptr = &::mascot::_DbDevExportInfos_default_instance_;
    new (ptr) ::mascot::DbDevExportInfos();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::DbDevExportInfos::InitAsDefaultInstance();
}

void InitDefaultsDbDevExportInfos() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsDbDevExportInfosImpl);
}

void InitDefaultsDeviceNameImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  {
    void* ptr = &::mascot::_DeviceName_default_instance_;
    new (ptr) ::mascot::DeviceName();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::DeviceName::InitAsDefaultInstance();
}

void InitDefaultsDeviceName() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsDeviceNameImpl);
}

void InitDefaultsDirectoryImportReplyImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  protobuf_error_2eproto::InitDefaultsError();
  protobuf_database_2eproto::InitDefaultsDbDevImportInfo();
  {
    void* ptr = &::mascot::_DirectoryImportReply_default_instance_;
    new (ptr) ::mascot::DirectoryImportReply();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::DirectoryImportReply::InitAsDefaultInstance();
}

void InitDefaultsDirectoryImportReply() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsDirectoryImportReplyImpl);
}

::google::protobuf::Metadata file_level_metadata[6];

const ::google::protobuf::uint32 TableStruct::offsets[] GOOGLE_PROTOBUF_ATTRIBUTE_SECTION_VARIABLE(protodesc_cold) = {
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DirectoryReply, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DirectoryReply, success_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DirectoryReply, error_),
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DbDevExportInfo, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DbDevExportInfo, name_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DbDevExportInfo, address_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DbDevExportInfo, host_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DbDevExportInfo, version_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DbDevExportInfo, pid_),
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DbDevImportInfo, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DbDevImportInfo, name_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DbDevImportInfo, address_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DbDevImportInfo, exported_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DbDevImportInfo, version_),
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DbDevExportInfos, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DbDevExportInfos, devinfo_),
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceName, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceName, name_),
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DirectoryImportReply, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DirectoryImportReply, success_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DirectoryImportReply, error_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DirectoryImportReply, info_),
};
static const ::google::protobuf::internal::MigrationSchema schemas[] GOOGLE_PROTOBUF_ATTRIBUTE_SECTION_VARIABLE(protodesc_cold) = {
  { 0, -1, sizeof(::mascot::DirectoryReply)},
  { 7, -1, sizeof(::mascot::DbDevExportInfo)},
  { 17, -1, sizeof(::mascot::DbDevImportInfo)},
  { 26, -1, sizeof(::mascot::DbDevExportInfos)},
  { 32, -1, sizeof(::mascot::DeviceName)},
  { 38, -1, sizeof(::mascot::DirectoryImportReply)},
};

static ::google::protobuf::Message const * const file_default_instances[] = {
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_DirectoryReply_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_DbDevExportInfo_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_DbDevImportInfo_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_DbDevExportInfos_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_DeviceName_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_DirectoryImportReply_default_instance_),
};

void protobuf_AssignDescriptors() {
  AddDescriptors();
  ::google::protobuf::MessageFactory* factory = NULL;
  AssignDescriptors(
      "database.proto", schemas, file_default_instances, TableStruct::offsets, factory,
      file_level_metadata, NULL, NULL);
}

void protobuf_AssignDescriptorsOnce() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &protobuf_AssignDescriptors);
}

void protobuf_RegisterTypes(const ::std::string&) GOOGLE_PROTOBUF_ATTRIBUTE_COLD;
void protobuf_RegisterTypes(const ::std::string&) {
  protobuf_AssignDescriptorsOnce();
  ::google::protobuf::internal::RegisterAllTypes(file_level_metadata, 6);
}

void AddDescriptorsImpl() {
  InitDefaults();
  static const char descriptor[] GOOGLE_PROTOBUF_ATTRIBUTE_SECTION_VARIABLE(protodesc_cold) = {
      "\n\016database.proto\022\006mascot\032\013error.proto\"\?\n"
      "\016DirectoryReply\022\017\n\007success\030\001 \001(\010\022\034\n\005erro"
      "r\030\002 \001(\0132\r.mascot.Error\"\\\n\017DbDevExportInf"
      "o\022\014\n\004name\030\001 \001(\t\022\017\n\007address\030\002 \001(\t\022\014\n\004host"
      "\030\003 \001(\t\022\017\n\007version\030\004 \001(\t\022\013\n\003pid\030\005 \001(\003\"S\n\017"
      "DbDevImportInfo\022\014\n\004name\030\001 \001(\t\022\017\n\007address"
      "\030\002 \001(\t\022\020\n\010exported\030\003 \001(\010\022\017\n\007version\030\004 \001("
      "\t\"<\n\020DbDevExportInfos\022(\n\007devinfo\030\001 \003(\0132\027"
      ".mascot.DbDevExportInfo\"\032\n\nDeviceName\022\014\n"
      "\004name\030\001 \001(\t\"l\n\024DirectoryImportReply\022\017\n\007s"
      "uccess\030\001 \001(\010\022\034\n\005error\030\002 \001(\0132\r.mascot.Err"
      "or\022%\n\004info\030\003 \001(\0132\027.mascot.DbDevImportInf"
      "o2\327\001\n\tDirectory\022A\n\014ExportDevice\022\027.mascot"
      ".DbDevExportInfo\032\026.mascot.DirectoryReply"
      "\"\000\022C\n\rExportDevices\022\030.mascot.DbDevExport"
      "Infos\032\026.mascot.DirectoryReply\"\000\022B\n\014Impor"
      "tDevice\022\022.mascot.DeviceName\032\034.mascot.Dir"
      "ectoryImportReply\"\000b\006proto3"
  };
  ::google::protobuf::DescriptorPool::InternalAddGeneratedFile(
      descriptor, 707);
  ::google::protobuf::MessageFactory::InternalRegisterGeneratedFile(
    "database.proto", &protobuf_RegisterTypes);
  ::protobuf_error_2eproto::AddDescriptors();
}

void AddDescriptors() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &AddDescriptorsImpl);
}
// Force AddDescriptors() to be called at dynamic initialization time.
struct StaticDescriptorInitializer {
  StaticDescriptorInitializer() {
    AddDescriptors();
  }
} static_descriptor_initializer;
}  // namespace protobuf_database_2eproto
namespace mascot {

// ===================================================================

void DirectoryReply::InitAsDefaultInstance() {
  ::mascot::_DirectoryReply_default_instance_._instance.get_mutable()->error_ = const_cast< ::mascot::Error*>(
      ::mascot::Error::internal_default_instance());
}
void DirectoryReply::clear_error() {
  if (GetArenaNoVirtual() == NULL && error_ != NULL) {
    delete error_;
  }
  error_ = NULL;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int DirectoryReply::kSuccessFieldNumber;
const int DirectoryReply::kErrorFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

DirectoryReply::DirectoryReply()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_database_2eproto::InitDefaultsDirectoryReply();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.DirectoryReply)
}
DirectoryReply::DirectoryReply(const DirectoryReply& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  if (from.has_error()) {
    error_ = new ::mascot::Error(*from.error_);
  } else {
    error_ = NULL;
  }
  success_ = from.success_;
  // @@protoc_insertion_point(copy_constructor:mascot.DirectoryReply)
}

void DirectoryReply::SharedCtor() {
  ::memset(&error_, 0, static_cast<size_t>(
      reinterpret_cast<char*>(&success_) -
      reinterpret_cast<char*>(&error_)) + sizeof(success_));
  _cached_size_ = 0;
}

DirectoryReply::~DirectoryReply() {
  // @@protoc_insertion_point(destructor:mascot.DirectoryReply)
  SharedDtor();
}

void DirectoryReply::SharedDtor() {
  if (this != internal_default_instance()) delete error_;
}

void DirectoryReply::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* DirectoryReply::descriptor() {
  ::protobuf_database_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_database_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const DirectoryReply& DirectoryReply::default_instance() {
  ::protobuf_database_2eproto::InitDefaultsDirectoryReply();
  return *internal_default_instance();
}

DirectoryReply* DirectoryReply::New(::google::protobuf::Arena* arena) const {
  DirectoryReply* n = new DirectoryReply;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void DirectoryReply::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.DirectoryReply)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  if (GetArenaNoVirtual() == NULL && error_ != NULL) {
    delete error_;
  }
  error_ = NULL;
  success_ = false;
  _internal_metadata_.Clear();
}

bool DirectoryReply::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.DirectoryReply)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // bool success = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(8u /* 8 & 0xFF */)) {

          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   bool, ::google::protobuf::internal::WireFormatLite::TYPE_BOOL>(
                 input, &success_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // .mascot.Error error = 2;
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(18u /* 18 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(
               input, mutable_error()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.DirectoryReply)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.DirectoryReply)
  return false;
#undef DO_
}

void DirectoryReply::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.DirectoryReply)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // bool success = 1;
  if (this->success() != 0) {
    ::google::protobuf::internal::WireFormatLite::WriteBool(1, this->success(), output);
  }

  // .mascot.Error error = 2;
  if (this->has_error()) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      2, *this->error_, output);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.DirectoryReply)
}

::google::protobuf::uint8* DirectoryReply::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.DirectoryReply)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // bool success = 1;
  if (this->success() != 0) {
    target = ::google::protobuf::internal::WireFormatLite::WriteBoolToArray(1, this->success(), target);
  }

  // .mascot.Error error = 2;
  if (this->has_error()) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageToArray(
        2, *this->error_, deterministic, target);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.DirectoryReply)
  return target;
}

size_t DirectoryReply::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.DirectoryReply)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // .mascot.Error error = 2;
  if (this->has_error()) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::MessageSize(
        *this->error_);
  }

  // bool success = 1;
  if (this->success() != 0) {
    total_size += 1 + 1;
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void DirectoryReply::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.DirectoryReply)
  GOOGLE_DCHECK_NE(&from, this);
  const DirectoryReply* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const DirectoryReply>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.DirectoryReply)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.DirectoryReply)
    MergeFrom(*source);
  }
}

void DirectoryReply::MergeFrom(const DirectoryReply& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.DirectoryReply)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  if (from.has_error()) {
    mutable_error()->::mascot::Error::MergeFrom(from.error());
  }
  if (from.success() != 0) {
    set_success(from.success());
  }
}

void DirectoryReply::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.DirectoryReply)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void DirectoryReply::CopyFrom(const DirectoryReply& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.DirectoryReply)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool DirectoryReply::IsInitialized() const {
  return true;
}

void DirectoryReply::Swap(DirectoryReply* other) {
  if (other == this) return;
  InternalSwap(other);
}
void DirectoryReply::InternalSwap(DirectoryReply* other) {
  using std::swap;
  swap(error_, other->error_);
  swap(success_, other->success_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata DirectoryReply::GetMetadata() const {
  protobuf_database_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_database_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

void DbDevExportInfo::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int DbDevExportInfo::kNameFieldNumber;
const int DbDevExportInfo::kAddressFieldNumber;
const int DbDevExportInfo::kHostFieldNumber;
const int DbDevExportInfo::kVersionFieldNumber;
const int DbDevExportInfo::kPidFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

DbDevExportInfo::DbDevExportInfo()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_database_2eproto::InitDefaultsDbDevExportInfo();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.DbDevExportInfo)
}
DbDevExportInfo::DbDevExportInfo(const DbDevExportInfo& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  name_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.name().size() > 0) {
    name_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.name_);
  }
  address_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.address().size() > 0) {
    address_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.address_);
  }
  host_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.host().size() > 0) {
    host_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.host_);
  }
  version_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.version().size() > 0) {
    version_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.version_);
  }
  pid_ = from.pid_;
  // @@protoc_insertion_point(copy_constructor:mascot.DbDevExportInfo)
}

void DbDevExportInfo::SharedCtor() {
  name_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  address_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  host_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  version_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  pid_ = GOOGLE_LONGLONG(0);
  _cached_size_ = 0;
}

DbDevExportInfo::~DbDevExportInfo() {
  // @@protoc_insertion_point(destructor:mascot.DbDevExportInfo)
  SharedDtor();
}

void DbDevExportInfo::SharedDtor() {
  name_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  address_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  host_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  version_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}

void DbDevExportInfo::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* DbDevExportInfo::descriptor() {
  ::protobuf_database_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_database_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const DbDevExportInfo& DbDevExportInfo::default_instance() {
  ::protobuf_database_2eproto::InitDefaultsDbDevExportInfo();
  return *internal_default_instance();
}

DbDevExportInfo* DbDevExportInfo::New(::google::protobuf::Arena* arena) const {
  DbDevExportInfo* n = new DbDevExportInfo;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void DbDevExportInfo::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.DbDevExportInfo)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  name_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  address_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  host_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  version_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  pid_ = GOOGLE_LONGLONG(0);
  _internal_metadata_.Clear();
}

bool DbDevExportInfo::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.DbDevExportInfo)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // string name = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(10u /* 10 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_name()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->name().data(), static_cast<int>(this->name().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.DbDevExportInfo.name"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // string address = 2;
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(18u /* 18 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_address()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->address().data(), static_cast<int>(this->address().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.DbDevExportInfo.address"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // string host = 3;
      case 3: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(26u /* 26 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_host()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->host().data(), static_cast<int>(this->host().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.DbDevExportInfo.host"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // string version = 4;
      case 4: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(34u /* 34 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_version()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->version().data(), static_cast<int>(this->version().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.DbDevExportInfo.version"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // int64 pid = 5;
      case 5: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(40u /* 40 & 0xFF */)) {

          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::int64, ::google::protobuf::internal::WireFormatLite::TYPE_INT64>(
                 input, &pid_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.DbDevExportInfo)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.DbDevExportInfo)
  return false;
#undef DO_
}

void DbDevExportInfo::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.DbDevExportInfo)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string name = 1;
  if (this->name().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->name().data(), static_cast<int>(this->name().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.DbDevExportInfo.name");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      1, this->name(), output);
  }

  // string address = 2;
  if (this->address().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->address().data(), static_cast<int>(this->address().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.DbDevExportInfo.address");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      2, this->address(), output);
  }

  // string host = 3;
  if (this->host().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->host().data(), static_cast<int>(this->host().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.DbDevExportInfo.host");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      3, this->host(), output);
  }

  // string version = 4;
  if (this->version().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->version().data(), static_cast<int>(this->version().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.DbDevExportInfo.version");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      4, this->version(), output);
  }

  // int64 pid = 5;
  if (this->pid() != 0) {
    ::google::protobuf::internal::WireFormatLite::WriteInt64(5, this->pid(), output);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.DbDevExportInfo)
}

::google::protobuf::uint8* DbDevExportInfo::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.DbDevExportInfo)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string name = 1;
  if (this->name().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->name().data(), static_cast<int>(this->name().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.DbDevExportInfo.name");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        1, this->name(), target);
  }

  // string address = 2;
  if (this->address().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->address().data(), static_cast<int>(this->address().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.DbDevExportInfo.address");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        2, this->address(), target);
  }

  // string host = 3;
  if (this->host().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->host().data(), static_cast<int>(this->host().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.DbDevExportInfo.host");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        3, this->host(), target);
  }

  // string version = 4;
  if (this->version().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->version().data(), static_cast<int>(this->version().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.DbDevExportInfo.version");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        4, this->version(), target);
  }

  // int64 pid = 5;
  if (this->pid() != 0) {
    target = ::google::protobuf::internal::WireFormatLite::WriteInt64ToArray(5, this->pid(), target);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.DbDevExportInfo)
  return target;
}

size_t DbDevExportInfo::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.DbDevExportInfo)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // string name = 1;
  if (this->name().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->name());
  }

  // string address = 2;
  if (this->address().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->address());
  }

  // string host = 3;
  if (this->host().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->host());
  }

  // string version = 4;
  if (this->version().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->version());
  }

  // int64 pid = 5;
  if (this->pid() != 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::Int64Size(
        this->pid());
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void DbDevExportInfo::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.DbDevExportInfo)
  GOOGLE_DCHECK_NE(&from, this);
  const DbDevExportInfo* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const DbDevExportInfo>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.DbDevExportInfo)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.DbDevExportInfo)
    MergeFrom(*source);
  }
}

void DbDevExportInfo::MergeFrom(const DbDevExportInfo& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.DbDevExportInfo)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  if (from.name().size() > 0) {

    name_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.name_);
  }
  if (from.address().size() > 0) {

    address_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.address_);
  }
  if (from.host().size() > 0) {

    host_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.host_);
  }
  if (from.version().size() > 0) {

    version_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.version_);
  }
  if (from.pid() != 0) {
    set_pid(from.pid());
  }
}

void DbDevExportInfo::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.DbDevExportInfo)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void DbDevExportInfo::CopyFrom(const DbDevExportInfo& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.DbDevExportInfo)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool DbDevExportInfo::IsInitialized() const {
  return true;
}

void DbDevExportInfo::Swap(DbDevExportInfo* other) {
  if (other == this) return;
  InternalSwap(other);
}
void DbDevExportInfo::InternalSwap(DbDevExportInfo* other) {
  using std::swap;
  name_.Swap(&other->name_);
  address_.Swap(&other->address_);
  host_.Swap(&other->host_);
  version_.Swap(&other->version_);
  swap(pid_, other->pid_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata DbDevExportInfo::GetMetadata() const {
  protobuf_database_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_database_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

void DbDevImportInfo::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int DbDevImportInfo::kNameFieldNumber;
const int DbDevImportInfo::kAddressFieldNumber;
const int DbDevImportInfo::kExportedFieldNumber;
const int DbDevImportInfo::kVersionFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

DbDevImportInfo::DbDevImportInfo()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_database_2eproto::InitDefaultsDbDevImportInfo();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.DbDevImportInfo)
}
DbDevImportInfo::DbDevImportInfo(const DbDevImportInfo& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  name_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.name().size() > 0) {
    name_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.name_);
  }
  address_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.address().size() > 0) {
    address_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.address_);
  }
  version_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.version().size() > 0) {
    version_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.version_);
  }
  exported_ = from.exported_;
  // @@protoc_insertion_point(copy_constructor:mascot.DbDevImportInfo)
}

void DbDevImportInfo::SharedCtor() {
  name_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  address_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  version_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  exported_ = false;
  _cached_size_ = 0;
}

DbDevImportInfo::~DbDevImportInfo() {
  // @@protoc_insertion_point(destructor:mascot.DbDevImportInfo)
  SharedDtor();
}

void DbDevImportInfo::SharedDtor() {
  name_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  address_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  version_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}

void DbDevImportInfo::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* DbDevImportInfo::descriptor() {
  ::protobuf_database_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_database_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const DbDevImportInfo& DbDevImportInfo::default_instance() {
  ::protobuf_database_2eproto::InitDefaultsDbDevImportInfo();
  return *internal_default_instance();
}

DbDevImportInfo* DbDevImportInfo::New(::google::protobuf::Arena* arena) const {
  DbDevImportInfo* n = new DbDevImportInfo;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void DbDevImportInfo::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.DbDevImportInfo)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  name_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  address_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  version_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  exported_ = false;
  _internal_metadata_.Clear();
}

bool DbDevImportInfo::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.DbDevImportInfo)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // string name = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(10u /* 10 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_name()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->name().data(), static_cast<int>(this->name().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.DbDevImportInfo.name"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // string address = 2;
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(18u /* 18 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_address()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->address().data(), static_cast<int>(this->address().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.DbDevImportInfo.address"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // bool exported = 3;
      case 3: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(24u /* 24 & 0xFF */)) {

          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   bool, ::google::protobuf::internal::WireFormatLite::TYPE_BOOL>(
                 input, &exported_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // string version = 4;
      case 4: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(34u /* 34 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_version()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->version().data(), static_cast<int>(this->version().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.DbDevImportInfo.version"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.DbDevImportInfo)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.DbDevImportInfo)
  return false;
#undef DO_
}

void DbDevImportInfo::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.DbDevImportInfo)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string name = 1;
  if (this->name().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->name().data(), static_cast<int>(this->name().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.DbDevImportInfo.name");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      1, this->name(), output);
  }

  // string address = 2;
  if (this->address().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->address().data(), static_cast<int>(this->address().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.DbDevImportInfo.address");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      2, this->address(), output);
  }

  // bool exported = 3;
  if (this->exported() != 0) {
    ::google::protobuf::internal::WireFormatLite::WriteBool(3, this->exported(), output);
  }

  // string version = 4;
  if (this->version().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->version().data(), static_cast<int>(this->version().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.DbDevImportInfo.version");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      4, this->version(), output);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.DbDevImportInfo)
}

::google::protobuf::uint8* DbDevImportInfo::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.DbDevImportInfo)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string name = 1;
  if (this->name().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->name().data(), static_cast<int>(this->name().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.DbDevImportInfo.name");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        1, this->name(), target);
  }

  // string address = 2;
  if (this->address().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->address().data(), static_cast<int>(this->address().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.DbDevImportInfo.address");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        2, this->address(), target);
  }

  // bool exported = 3;
  if (this->exported() != 0) {
    target = ::google::protobuf::internal::WireFormatLite::WriteBoolToArray(3, this->exported(), target);
  }

  // string version = 4;
  if (this->version().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->version().data(), static_cast<int>(this->version().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.DbDevImportInfo.version");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        4, this->version(), target);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.DbDevImportInfo)
  return target;
}

size_t DbDevImportInfo::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.DbDevImportInfo)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // string name = 1;
  if (this->name().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->name());
  }

  // string address = 2;
  if (this->address().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->address());
  }

  // string version = 4;
  if (this->version().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->version());
  }

  // bool exported = 3;
  if (this->exported() != 0) {
    total_size += 1 + 1;
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void DbDevImportInfo::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.DbDevImportInfo)
  GOOGLE_DCHECK_NE(&from, this);
  const DbDevImportInfo* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const DbDevImportInfo>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.DbDevImportInfo)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.DbDevImportInfo)
    MergeFrom(*source);
  }
}

void DbDevImportInfo::MergeFrom(const DbDevImportInfo& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.DbDevImportInfo)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  if (from.name().size() > 0) {

    name_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.name_);
  }
  if (from.address().size() > 0) {

    address_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.address_);
  }
  if (from.version().size() > 0) {

    version_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.version_);
  }
  if (from.exported() != 0) {
    set_exported(from.exported());
  }
}

void DbDevImportInfo::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.DbDevImportInfo)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void DbDevImportInfo::CopyFrom(const DbDevImportInfo& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.DbDevImportInfo)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool DbDevImportInfo::IsInitialized() const {
  return true;
}

void DbDevImportInfo::Swap(DbDevImportInfo* other) {
  if (other == this) return;
  InternalSwap(other);
}
void DbDevImportInfo::InternalSwap(DbDevImportInfo* other) {
  using std::swap;
  name_.Swap(&other->name_);
  address_.Swap(&other->address_);
  version_.Swap(&other->version_);
  swap(exported_, other->exported_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata DbDevImportInfo::GetMetadata() const {
  protobuf_database_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_database_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

void DbDevExportInfos::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int DbDevExportInfos::kDevinfoFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

DbDevExportInfos::DbDevExportInfos()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_database_2eproto::InitDefaultsDbDevExportInfos();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.DbDevExportInfos)
}
DbDevExportInfos::DbDevExportInfos(const DbDevExportInfos& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      devinfo_(from.devinfo_),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  // @@protoc_insertion_point(copy_constructor:mascot.DbDevExportInfos)
}

void DbDevExportInfos::SharedCtor() {
  _cached_size_ = 0;
}

DbDevExportInfos::~DbDevExportInfos() {
  // @@protoc_insertion_point(destructor:mascot.DbDevExportInfos)
  SharedDtor();
}

void DbDevExportInfos::SharedDtor() {
}

void DbDevExportInfos::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* DbDevExportInfos::descriptor() {
  ::protobuf_database_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_database_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const DbDevExportInfos& DbDevExportInfos::default_instance() {
  ::protobuf_database_2eproto::InitDefaultsDbDevExportInfos();
  return *internal_default_instance();
}

DbDevExportInfos* DbDevExportInfos::New(::google::protobuf::Arena* arena) const {
  DbDevExportInfos* n = new DbDevExportInfos;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void DbDevExportInfos::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.DbDevExportInfos)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  devinfo_.Clear();
  _internal_metadata_.Clear();
}

bool DbDevExportInfos::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.DbDevExportInfos)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // repeated .mascot.DbDevExportInfo devinfo = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(10u /* 10 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(input, add_devinfo()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.DbDevExportInfos)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.DbDevExportInfos)
  return false;
#undef DO_
}

void DbDevExportInfos::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.DbDevExportInfos)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // repeated .mascot.DbDevExportInfo devinfo = 1;
  for (unsigned int i = 0,
      n = static_cast<unsigned int>(this->devinfo_size()); i < n; i++) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      1, this->devinfo(static_cast<int>(i)), output);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.DbDevExportInfos)
}

::google::protobuf::uint8* DbDevExportInfos::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.DbDevExportInfos)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // repeated .mascot.DbDevExportInfo devinfo = 1;
  for (unsigned int i = 0,
      n = static_cast<unsigned int>(this->devinfo_size()); i < n; i++) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageToArray(
        1, this->devinfo(static_cast<int>(i)), deterministic, target);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.DbDevExportInfos)
  return target;
}

size_t DbDevExportInfos::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.DbDevExportInfos)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // repeated .mascot.DbDevExportInfo devinfo = 1;
  {
    unsigned int count = static_cast<unsigned int>(this->devinfo_size());
    total_size += 1UL * count;
    for (unsigned int i = 0; i < count; i++) {
      total_size +=
        ::google::protobuf::internal::WireFormatLite::MessageSize(
          this->devinfo(static_cast<int>(i)));
    }
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void DbDevExportInfos::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.DbDevExportInfos)
  GOOGLE_DCHECK_NE(&from, this);
  const DbDevExportInfos* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const DbDevExportInfos>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.DbDevExportInfos)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.DbDevExportInfos)
    MergeFrom(*source);
  }
}

void DbDevExportInfos::MergeFrom(const DbDevExportInfos& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.DbDevExportInfos)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  devinfo_.MergeFrom(from.devinfo_);
}

void DbDevExportInfos::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.DbDevExportInfos)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void DbDevExportInfos::CopyFrom(const DbDevExportInfos& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.DbDevExportInfos)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool DbDevExportInfos::IsInitialized() const {
  return true;
}

void DbDevExportInfos::Swap(DbDevExportInfos* other) {
  if (other == this) return;
  InternalSwap(other);
}
void DbDevExportInfos::InternalSwap(DbDevExportInfos* other) {
  using std::swap;
  devinfo_.InternalSwap(&other->devinfo_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata DbDevExportInfos::GetMetadata() const {
  protobuf_database_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_database_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

void DeviceName::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int DeviceName::kNameFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

DeviceName::DeviceName()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_database_2eproto::InitDefaultsDeviceName();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.DeviceName)
}
DeviceName::DeviceName(const DeviceName& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  name_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.name().size() > 0) {
    name_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.name_);
  }
  // @@protoc_insertion_point(copy_constructor:mascot.DeviceName)
}

void DeviceName::SharedCtor() {
  name_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  _cached_size_ = 0;
}

DeviceName::~DeviceName() {
  // @@protoc_insertion_point(destructor:mascot.DeviceName)
  SharedDtor();
}

void DeviceName::SharedDtor() {
  name_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}

void DeviceName::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* DeviceName::descriptor() {
  ::protobuf_database_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_database_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const DeviceName& DeviceName::default_instance() {
  ::protobuf_database_2eproto::InitDefaultsDeviceName();
  return *internal_default_instance();
}

DeviceName* DeviceName::New(::google::protobuf::Arena* arena) const {
  DeviceName* n = new DeviceName;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void DeviceName::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.DeviceName)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  name_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  _internal_metadata_.Clear();
}

bool DeviceName::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.DeviceName)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // string name = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(10u /* 10 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_name()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->name().data(), static_cast<int>(this->name().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.DeviceName.name"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.DeviceName)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.DeviceName)
  return false;
#undef DO_
}

void DeviceName::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.DeviceName)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string name = 1;
  if (this->name().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->name().data(), static_cast<int>(this->name().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.DeviceName.name");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      1, this->name(), output);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.DeviceName)
}

::google::protobuf::uint8* DeviceName::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.DeviceName)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string name = 1;
  if (this->name().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->name().data(), static_cast<int>(this->name().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.DeviceName.name");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        1, this->name(), target);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.DeviceName)
  return target;
}

size_t DeviceName::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.DeviceName)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // string name = 1;
  if (this->name().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->name());
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void DeviceName::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.DeviceName)
  GOOGLE_DCHECK_NE(&from, this);
  const DeviceName* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const DeviceName>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.DeviceName)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.DeviceName)
    MergeFrom(*source);
  }
}

void DeviceName::MergeFrom(const DeviceName& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.DeviceName)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  if (from.name().size() > 0) {

    name_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.name_);
  }
}

void DeviceName::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.DeviceName)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void DeviceName::CopyFrom(const DeviceName& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.DeviceName)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool DeviceName::IsInitialized() const {
  return true;
}

void DeviceName::Swap(DeviceName* other) {
  if (other == this) return;
  InternalSwap(other);
}
void DeviceName::InternalSwap(DeviceName* other) {
  using std::swap;
  name_.Swap(&other->name_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata DeviceName::GetMetadata() const {
  protobuf_database_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_database_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

void DirectoryImportReply::InitAsDefaultInstance() {
  ::mascot::_DirectoryImportReply_default_instance_._instance.get_mutable()->error_ = const_cast< ::mascot::Error*>(
      ::mascot::Error::internal_default_instance());
  ::mascot::_DirectoryImportReply_default_instance_._instance.get_mutable()->info_ = const_cast< ::mascot::DbDevImportInfo*>(
      ::mascot::DbDevImportInfo::internal_default_instance());
}
void DirectoryImportReply::clear_error() {
  if (GetArenaNoVirtual() == NULL && error_ != NULL) {
    delete error_;
  }
  error_ = NULL;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int DirectoryImportReply::kSuccessFieldNumber;
const int DirectoryImportReply::kErrorFieldNumber;
const int DirectoryImportReply::kInfoFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

DirectoryImportReply::DirectoryImportReply()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_database_2eproto::InitDefaultsDirectoryImportReply();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.DirectoryImportReply)
}
DirectoryImportReply::DirectoryImportReply(const DirectoryImportReply& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  if (from.has_error()) {
    error_ = new ::mascot::Error(*from.error_);
  } else {
    error_ = NULL;
  }
  if (from.has_info()) {
    info_ = new ::mascot::DbDevImportInfo(*from.info_);
  } else {
    info_ = NULL;
  }
  success_ = from.success_;
  // @@protoc_insertion_point(copy_constructor:mascot.DirectoryImportReply)
}

void DirectoryImportReply::SharedCtor() {
  ::memset(&error_, 0, static_cast<size_t>(
      reinterpret_cast<char*>(&success_) -
      reinterpret_cast<char*>(&error_)) + sizeof(success_));
  _cached_size_ = 0;
}

DirectoryImportReply::~DirectoryImportReply() {
  // @@protoc_insertion_point(destructor:mascot.DirectoryImportReply)
  SharedDtor();
}

void DirectoryImportReply::SharedDtor() {
  if (this != internal_default_instance()) delete error_;
  if (this != internal_default_instance()) delete info_;
}

void DirectoryImportReply::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* DirectoryImportReply::descriptor() {
  ::protobuf_database_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_database_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const DirectoryImportReply& DirectoryImportReply::default_instance() {
  ::protobuf_database_2eproto::InitDefaultsDirectoryImportReply();
  return *internal_default_instance();
}

DirectoryImportReply* DirectoryImportReply::New(::google::protobuf::Arena* arena) const {
  DirectoryImportReply* n = new DirectoryImportReply;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void DirectoryImportReply::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.DirectoryImportReply)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  if (GetArenaNoVirtual() == NULL && error_ != NULL) {
    delete error_;
  }
  error_ = NULL;
  if (GetArenaNoVirtual() == NULL && info_ != NULL) {
    delete info_;
  }
  info_ = NULL;
  success_ = false;
  _internal_metadata_.Clear();
}

bool DirectoryImportReply::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.DirectoryImportReply)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // bool success = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(8u /* 8 & 0xFF */)) {

          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   bool, ::google::protobuf::internal::WireFormatLite::TYPE_BOOL>(
                 input, &success_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // .mascot.Error error = 2;
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(18u /* 18 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(
               input, mutable_error()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // .mascot.DbDevImportInfo info = 3;
      case 3: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(26u /* 26 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(
               input, mutable_info()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.DirectoryImportReply)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.DirectoryImportReply)
  return false;
#undef DO_
}

void DirectoryImportReply::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.DirectoryImportReply)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // bool success = 1;
  if (this->success() != 0) {
    ::google::protobuf::internal::WireFormatLite::WriteBool(1, this->success(), output);
  }

  // .mascot.Error error = 2;
  if (this->has_error()) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      2, *this->error_, output);
  }

  // .mascot.DbDevImportInfo info = 3;
  if (this->has_info()) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      3, *this->info_, output);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.DirectoryImportReply)
}

::google::protobuf::uint8* DirectoryImportReply::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.DirectoryImportReply)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // bool success = 1;
  if (this->success() != 0) {
    target = ::google::protobuf::internal::WireFormatLite::WriteBoolToArray(1, this->success(), target);
  }

  // .mascot.Error error = 2;
  if (this->has_error()) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageToArray(
        2, *this->error_, deterministic, target);
  }

  // .mascot.DbDevImportInfo info = 3;
  if (this->has_info()) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageToArray(
        3, *this->info_, deterministic, target);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.DirectoryImportReply)
  return target;
}

size_t DirectoryImportReply::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.DirectoryImportReply)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // .mascot.Error error = 2;
  if (this->has_error()) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::MessageSize(
        *this->error_);
  }

  // .mascot.DbDevImportInfo info = 3;
  if (this->has_info()) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::MessageSize(
        *this->info_);
  }

  // bool success = 1;
  if (this->success() != 0) {
    total_size += 1 + 1;
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void DirectoryImportReply::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.DirectoryImportReply)
  GOOGLE_DCHECK_NE(&from, this);
  const DirectoryImportReply* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const DirectoryImportReply>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.DirectoryImportReply)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.DirectoryImportReply)
    MergeFrom(*source);
  }
}

void DirectoryImportReply::MergeFrom(const DirectoryImportReply& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.DirectoryImportReply)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  if (from.has_error()) {
    mutable_error()->::mascot::Error::MergeFrom(from.error());
  }
  if (from.has_info()) {
    mutable_info()->::mascot::DbDevImportInfo::MergeFrom(from.info());
  }
  if (from.success() != 0) {
    set_success(from.success());
  }
}

void DirectoryImportReply::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.DirectoryImportReply)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void DirectoryImportReply::CopyFrom(const DirectoryImportReply& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.DirectoryImportReply)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool DirectoryImportReply::IsInitialized() const {
  return true;
}

void DirectoryImportReply::Swap(DirectoryImportReply* other) {
  if (other == this) return;
  InternalSwap(other);
}
void DirectoryImportReply::InternalSwap(DirectoryImportReply* other) {
  using std::swap;
  swap(error_, other->error_);
  swap(info_, other->info_);
  swap(success_, other->success_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata DirectoryImportReply::GetMetadata() const {
  protobuf_database_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_database_2eproto::file_level_metadata[kIndexInFileMessages];
}


// @@protoc_insertion_point(namespace_scope)
}  // namespace mascot

// @@protoc_insertion_point(global_scope)
